library RegisterAnyUnitEvent

private constant function True takes nothing returns boolean
    return true
endfunction

function RegisterAnyUnitEvent takes playerunitevent E, code Cond, code Act returns trigger
    local trigger T = CreateTrigger()
    local integer index = 0
    loop
        call TriggerRegisterPlayerUnitEvent(T, Player(index), E, Condition(function True))
        set index = index + 1
        exitwhen index == bj_MAX_PLAYER_SLOTS
    endloop
    if Cond != null then
        call TriggerAddCondition(T, Condition(Cond))
    endif
    if Act != null then
        call TriggerAddAction(T, Act)
    endif
    return T
endfunction

endlibrary